#include <iostream>

struct thing {
	int id;
	thing(int id) : id(id) {
		std::cout << "thing " << id << " constructed\n";
	}
	~thing() { std::cout << "thing " << id << " destroyed\n"; }
};

struct base {
	thing t1 = { 1 };
	thing t2 = { 2 };

	base() { std::cout << "base constructed\n"; }
	~base() { std::cout << "base destroyed\n"; }
};

struct derived : base {
	thing t3 = { 3 };
	thing t4 = { 4 };

	derived() { std::cout << "derived constructed\n"; }
	~derived() { std::cout << "derived destroyed\n"; }
};

int main() {
	derived d;
	std::cout << "---\n";
}
