#include <iostream>

struct base {
	int value;
	base(int v) : value(v) {
		std::cout << "Base ctor with " << v << '\n';
	}
};

struct derived : base {
	using base::base;
	derived() : base{ 1 } { std::cout << "Derived ctor\n"; }
};

int main() {
	derived d1;
	std::cout << d1.value << '\n';
	derived d2{ 2 };
	std::cout << d2.value << '\n';
}
