#include <iostream>

struct animal {};
struct dog : animal {};

void make_sound(animal&) {
	std::cout << "<generic animal sound>\n";
}

void make_sound(dog&) {
	std::cout << "Woof!\n";
}

int main() {
	dog fido;
	animal& ref = fido;
	animal* ptr = &fido;

	auto& dref = fido;
	auto* dptr = &fido;

	make_sound(fido);
	make_sound(ref);
	make_sound(*ptr);
	make_sound(dref);
	make_sound(*dptr);
}
